/*  n digits of PI                                       */
/*  'Spigot' algorithm originally due to Stanley Rabinowitz */
 
/* all 'long's must be 32 bit integers in this program */
/* 16 bit integers will not work, set compiler switch accordingly */
 
#include <stdio.h>
#include <stdlib.h>
 
/* number of zeros in base */
#define d (4)
 
/* 10^d */
#define R (10000)
 
void main(int argc, char **argv) {
 
   long i, k, q, *a, n, m;
 
   if(argc < 2) {
      printf("Usage: pi <n>\n"); exit(0);
   }
 
   if(atol(argv[1]) < 1L) {
      printf("Usage: pi <number>\n"); exit(0);
   }
 
   /* number-of-digits-wanted / d + 1 */
   n = atol(argv[1])/4+1;
 
   /* storage array[0..m] (const is log 10 base 2) */
   m = ((long)(3.322*n*d));
   a = malloc((1+m)*sizeof(long));
 
   if(a == NULL) {
      printf("malloc failed\n"); exit(0);
   }
 
   for(i = 0; i < m; i++)
      a[i] = 2;
   a[m] = 4;
 
   for(i = n; i--;) {
      q = 0;
 
      for(k = m; k > 0; k--) {
         long t = 2*k + 1;
 
         a[k] = a[k]*R + q;
         a[k] -= t*(q = a[k]/t);
         q *= k;
      }
 
      a[0] = a[0]*R + q;
      a[0] -= R*(q = a[0]/R);
 
      printf("%04d", q);
      fflush(stdout);
   }
   printf("\n");
}
