#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tos.h>
#include <math.h>

extern void add(int *, int *, int *, int);
/*
void add(int *a1, int *a2, int *sum, int n)
{
  int i,s,o = 0;
  int *ap1 = &a1[n-1],
      *ap2 = &a2[n-1],
      *sump = &sum[n-1];
  
  for (i=0; i<n; i++) {
    s = *ap1-- + *ap2-- + o;
    o = s/10000;
    *sump-- = s%10000;
  }
}
*/

extern void sub(int *, int *, int *, int);
/*
void sub(int *a1, int *a2, int *diff, int n)
{
  int i,o = 0;
  int d;
  int *ap1 = &a1[n-1],
      *ap2 = &a2[n-1],
      *diffp = &diff[n-1];
  
  for (i=0; i<n; i++) {
    if ((d = *ap1-- - *ap2-- - o) < 0) {
      o = 1;
      *diffp-- = d+10000;
    }
    else {
      o = 0;
      *diffp-- = d;
    }
  }
}
*/

extern void divide(unsigned int *, unsigned long, unsigned int *,
                   unsigned int);
/*
void divide(unsigned int *d1, unsigned long d2, unsigned int *quot,
            unsigned int n)
{
  unsigned int i;
  unsigned long q,o = 0;
  unsigned int *dp1 = d1,
               *quotp = quot;
      
  for (i=0; i<n; i++) {
    q = (long)*dp1++ + o*10000L;
    *quotp++ = (o = q/d2);
    o = q - o*d2;
  }
}
*/

void printterm(unsigned int *t, unsigned int n)
{
  unsigned int i;

  printf("printterm:");  
  for (i=0; i<n; i++) {
    if ((i%20) == 0) printf("\n");
    printf("%04d",t[i]);
  }
  printf("\n");
  getchar();
}

void pi(unsigned int n,unsigned int **result)
{
  int pm,tc1,tc2,tcall,percent,dpercent,M = (n+8+3)/4;
  long i;
  unsigned int *sum   = (unsigned int *) calloc(M,sizeof(int)),
               *term1 = (unsigned int *) calloc(M,sizeof(int)),
               *term2 = (unsigned int *) calloc(M,sizeof(int));
  
  /* printf("M=%d 4*M=%d\n",M,4*M); */
  dpercent = (n<=150 ? 200 : (n<=250 ? 100 : (n<=2500 ? 10 : 1)));
  sum[0] = term1[0] = 2000;
  pm = 0;
  tc1 = (n+8)/log10(5.0) + 1;
  tc2 = (n+8)/log10(239.0) + 1;
  tcall = tc1 + tc2;
  percent = 0;
  
  if (n>2500)
    printf("\n%5.1f%%",0.0);
  else
    printf("\n%3d%%",0);
  fflush(stdout);
  /*printf("\ntc1=%d  tc2=%d\n\n",tc1,tc2); fflush(stdout);*/
  
  for (i=1; i<tc1;) {
    i += 2;
    /* printf("\rit1: %d/%d ",i,tc1); fflush(stdout); */
    if (i*1000/tcall >= percent+dpercent) {
      if (n>2500)
        printf("\r%5.1f%%",0.1*(percent+=dpercent));
      else
        printf("\r%3d%%",(percent+=dpercent)/10);
      fflush(stdout);
    }
    divide(term1,25L,term1,M);
    divide(term1,i,term2,M);
    if (pm) {
      add(sum,term2,sum,M);
      pm = 0;
    }
    else {
      /*
      printf("\nit1=%d\n",i);
      printterm(sum,M);
      printterm(term2,M);
      */
      sub(sum,term2,sum,M);
      /*printterm(sum,M);*/
      pm = 1;
    }
  }
  /*printf("\n");*/
  /*
    printf("\nit1: %d/%d\n",i,tc1);
    printterm(term2,M);
  */
  add(sum,sum,sum,M);
  add(sum,sum,sum,M);
  
  memset(term1,0,(long)M*(long)sizeof(int));  
  term1[0] = 10000;
  divide(term1,239L,term1,M);
  sub(sum,term1,sum,M);
  pm = 1;
  for (i=1; i<tc2;) {
    i += 2;
    /*printf("\rit2: %d/%d",i,tc2); fflush(stdout);*/
    if ((i+tc1)*1000/tcall >= percent+dpercent) {
      if (n>2500)
        printf("\r%5.1f%%",0.1*(percent+=dpercent));
      else
        printf("\r%3d%%",(percent+=dpercent)/10);
      fflush(stdout);
    }
    divide(term1,57121L,term1,M);
    divide(term1,i,term2,M);
    if (pm) {
      add(sum,term2,sum,M);
      pm = 0;
    }
    else {
      sub(sum,term2,sum,M);
      pm = 1;
    }
  }
  /*printf("\n");*/
  /*
    printf("\nit2: %d/%d\n",i,tc2);
    printterm(term2,M);
  */
  add(sum,sum,sum,M);
  add(sum,sum,sum,M);

  if (n<=2500)
    printf("\r%3d%%\n",100);
  else
    printf("\r%5.1f%%\n",100.);
 fflush(stdout);
 
  *result = sum;
}

long getticks()
{
  long old_ss = Super(0L);
  long ticks  = *((long *)0x4BA);
  Super(old_ss);
  return ticks;
}

int main(argc,argv)
int argc;
char **argv;
{
  unsigned int i,n,*result;
  long tick0, tick1;
  char file[256];
  FILE *f;
  
  /*
  if (argc < 2) {
    printf("Usage: pi <stellen_anzahl>\n");
    return 1;
  }
  
  n=atoi(argv[1]);
  */
  printf("\033E\033H\nComputation of PI\n");
  printf(            "=================\n\n");
  printf("Formula of John Machin (1706): PI = 4*(4*arctan(1/5)-arctan(1/239))\n\n");
  printf("How many digits: ");      
  scanf("%d\n",&n);
  tick0 = getticks();
  pi(n,&result);
  tick1 = getticks();
  printf("\nTime = %g seconds.\n",(tick1-tick0)*0.005);
  while (1) {
    printf("\nEnter file name [PRN: = Printer, - = Screen, <RETURN> = Exit]: ");
    if (gets(file) == NULL) return 0;
    if (*file == '\0') return 0;
    if (*file == '-')
      f = stdout;
    else {
      f = fopen(file,"w");
      if (f == NULL) {
        printf("\nOpen error on file \"%s\"\n",file);
        continue;
      }
    }
    fprintf(f,"\nPI = 3.",n);
    for (i=0; i<n/4; i++) {
      if ((i%20) == 0) fprintf(f,"\n");
      fprintf(f,"%04d",result[i]);
    }
    fprintf(f,"\n");
    if (f != stdout) fclose(f);
    /*
    printf("\nPress RETURN to continue...");
    getchar();
    */
  }
  return 0;
}